import argparse
import sys
from py4j.java_gateway import JavaGateway
from py4j.java_gateway import GatewayParameters
from py4j.java_gateway import CallbackServerParameters
from py4j.java_gateway import get_field
from BasicBot import BasicBot
from DisplayInfo import DisplayInfo
from SandBag import SandBag


def check_args(args):
        for i in range(argc):
                if args[i] == "-n" or args[i] == "--n" or args[i] == "--number":
                        global GAME_NUM
                        GAME_NUM = int(args[i+1])

def start_game():       
    p1 = BasicBot(gateway)
    p2 = DisplayInfo(gateway)
    manager.registerAI(p1.__class__.__name__, p1)
    manager.registerAI(p2.__class__.__name__, p2)
    print("Start game")
    
    game = manager.createGame(
                    "ZEN", "ZEN", 
                    p1.__class__.__name__, 
                    p2.__class__.__name__,
                    GAME_NUM)
    manager.runGame(game)
    
    print("After game")
    sys.stdout.flush()


def close_gateway():
    gateway.close_callback_server()
    gateway.close()

def main_process():
	check_args(args)
	start_game()
	close_gateway()

args = sys.argv
argc = len(args)
GAME_NUM = 1
gateway = JavaGateway(gateway_parameters=GatewayParameters(port=6500), callback_server_parameters=CallbackServerParameters());
manager = gateway.entry_point

main_process()
